<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="父id" prop="parentId">
        <el-input v-model="formData.parentId" placeholder="请输入父id" />
      </el-form-item>
      <el-form-item label="月嫂id" prop="yuesaoId">
        <el-input v-model="formData.yuesaoId" placeholder="请输入月嫂id" />
      </el-form-item>
      <el-form-item label="订单id" prop="orderId">
        <el-input v-model="formData.orderId" placeholder="请输入订单id" />
      </el-form-item>
      <el-form-item label="评价" prop="comment">
        <el-input v-model="formData.comment" placeholder="请输入评价" />
      </el-form-item>
      <el-form-item label="标签" prop="remarks">
        <el-input v-model="formData.remarks" placeholder="请输入标签" />
      </el-form-item>
      <el-form-item label="评分" prop="point">
        <el-input v-model="formData.point" placeholder="请输入评分" />
      </el-form-item>
      <el-form-item label="是否显示 0=不显示 1=显示" prop="isShow">
        <el-input v-model="formData.isShow" placeholder="请输入是否显示 0=不显示 1=显示" />
      </el-form-item>
      <el-form-item label="评价图片" prop="picUrl">
        <el-input v-model="formData.picUrl" placeholder="请输入评价图片" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as OrderEvaluateApi from '@/api/yuesao/orderEvaluate'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  parentId: undefined,
  yuesaoId: undefined,
  orderId: undefined,
  comment: undefined,
  remarks: undefined,
  point: undefined,
  isShow: undefined,
  picUrl: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrderEvaluateApi.getOrderEvaluate(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrderEvaluateApi.OrderEvaluateVO
    if (formType.value === 'create') {
      await OrderEvaluateApi.createOrderEvaluate(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrderEvaluateApi.updateOrderEvaluate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    parentId: undefined,
    yuesaoId: undefined,
    orderId: undefined,
    comment: undefined,
    remarks: undefined,
    point: undefined,
    isShow: undefined,
    picUrl: undefined
  }
  formRef.value?.resetFields()
}
</script>
